
Object subclass: #ConfigurationOfTabular
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfTabular'!

!ConfigurationOfTabular class methodsFor: 'development support' stamp: 'VincentBlondeau 12/11/2014 10:46'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfTabular class methodsFor: 'private' stamp: 'VincentBlondeau 12/11/2014 10:46'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfTabular class methodsFor: 'private' stamp: 'VincentBlondeau 12/11/2014 10:46'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfTabular class methodsFor: 'private' stamp: 'VincentBlondeau 12/11/2014 10:46'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfTabular class methodsFor: 'metacello tool support' stamp: 'VincentBlondeau 12/11/2014 10:46'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfTabular class methodsFor: 'loading' stamp: 'VincentBlondeau 12/11/2014 10:46'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfTabular class methodsFor: 'loading' stamp: 'VincentBlondeau 12/11/2014 10:46'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfTabular class methodsFor: 'loading' stamp: 'VincentBlondeau 12/11/2014 10:46'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfTabular class methodsFor: 'accessing' stamp: 'VincentBlondeau 12/11/2014 10:46'!
project

	^self new project! !

!ConfigurationOfTabular class methodsFor: 'development support' stamp: 'VincentBlondeau 12/11/2014 10:46'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfTabular methodsFor: 'baselines' stamp: 'VincentBlondeau 12/11/2014 10:47'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/Tabular'.
		spec package: 'Tabular'.
		spec group: 'Core' with: #('Tabular' ). ].
! !

!ConfigurationOfTabular methodsFor: 'accessing' stamp: 'VincentBlondeau 12/11/2014 10:46'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfTabular methodsFor: 'symbolic versions' stamp: 'VincentBlondeau 12/11/2014 10:46'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfTabular methodsFor: 'accessing' stamp: 'VincentBlondeau 12/11/2014 10:46'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !
